/**
 * 加载覆盖层
 * @extends FR.OB
 *
 */
WT.LoadingCover = FR.extend(FR.OB, {

    _defaultConfig: function () {
        return $.extend(WT.LoadingCover.superclass._defaultConfig.apply(), {
        });
    },

    _init: function () {
        WT.LoadingCover.superclass._init.apply(this, arguments);
        this._initView();
    },

    _initView: function () {
        this.element = $('<div class="wt-absolute-layout wt-animation-effect"></div>');
        this.loading = $('<div class="load-indicator"></div>');
        this.loading.css({
            position: 'absolute',
            width: 64,
            height: 64
        });

        var $wholeIndicator = $("<div class='loading-whole-indicator-pic'></div>");
        if (FR.Browser.supportCSSAnimation()) {
            // 整体加载动画
            $wholeIndicator = $("<div class='loading-whole-indicator'></div>");
            $("<div class='rect1'></div>").appendTo($wholeIndicator);
            $("<div class='rect2'></div>").appendTo($wholeIndicator);
            $("<div class='rect3'></div>").appendTo($wholeIndicator);
        }

        this.loading.append($wholeIndicator);
        this.element.css({
            background: 'transparent',
            'z-index': 10001
        });
        this.element.append(this.loading);
    },

    resize: function (width, height) {
        this.element.css({
            left: 0,
            top: 0,
            width: width,
            height: height
        });
        this.loading.css({
            left: Math.floor((width - 64) / 2),
            top: Math.floor((height - 64) / 2)
        })
    },

    mount: function (parent) {
        this.element.appendTo(parent);
    },

    destroy: function () {
        this.loading.remove();
        this.loading = null;
        this.element.remove();
        this.element = null;
    }

});