/**
 * 校验失败时错误弹框
 * @extends FR.OB
 *
 */
WT.VerifyPopup = FR.extend(FR.OB, {

    _defaultConfig: function () {
        return $.extend(WT.VerifyPopup.superclass._defaultConfig.apply(), {
            left: 18,
            top: 30,
            errors: [] //[{sheetIndex, position, msg}]
        });
    },

    _init: function () {
        WT.VerifyPopup.superclass._init.apply(this, arguments);
        this._initView();
        $('body').append(this.element);
    },

    _initView: function () {
        var o = this.options, self = this;
        this.element = $('<div/>').addClass('verify-error-container');
        var $errorMsgDiv = $('<div/>').addClass('verify-error-messages').appendTo(this.element);
        var $tableWrapper = $('<div/>').addClass('verify-table-wrapper').appendTo($errorMsgDiv);
        var $table = $("<table cellspacing='0' cellpadding='0'>").addClass('verify-table').css('width', 200).appendTo($tableWrapper);
        var $tbody = $("<tbody>").appendTo($table);
        this.tds = [];
        WT.each(o.errors, function (error, idx) {
            var $td = $('<td class="wt-verify-item"/>')
                .css('cursor', 'pointer')
                .text(error.msg)
                .attr('title', 'Sheet' + (parseInt(error.sheetIndex) + 1) + '-' + error.position + ':' + error.msg)
                .click(function () {
                    self.fireEvent(WT.VerifyPopup.EVENT_SELECT, idx);
                });
            $tbody.append($("<tr" + (idx % 2 === 0 ? " class='verify-row-alt'" : "") + "></tr>").append($td));
            this.tds.push($td);
        }, this);
        this.collapseDiv = $('<div class="verify-collapse"/>')
            .click(function () {
                self.fireEvent(WT.VerifyPopup.EVENT_CLOSE);
            })
            .attr('title', FR.i18nText("Fine-Engine_Click_To_Shrink_Panel"))
            .appendTo($errorMsgDiv);
    },

    destroy: function () {
        WT.each(this.tds, function (td) {
            td.off('click');
            td.remove();
        });
        this.tds = null;

        this.collapseDiv.off('click');
        this.collapseDiv.remove();
        this.collapseDiv = null;

        this.element.remove();
        this.element = null;
        this.purgeListeners();
    }

});

WT.VerifyPopup.EVENT_CLOSE = 'EVENT_CLOSE';
WT.VerifyPopup.EVENT_SELECT = 'EVENT_SELECT';