/**
 * Created by rinoux on 2017/4/13.
 */
WT.MultifileEditor = FR.extend(WT.Widget, {

    TYPE: 'WT.MultifileEditor',

    _defaultConfig: function () {
        return $.extend(WT.Button.superclass._defaultConfig.apply(), {
            //supportNull: true,
            //errorInfo4Null:'',
            allowBlank: true,
            errorMsg4Blank: FR.i18nText('Fine-Engine_Write_Enhanc_Not_Support_Null'),
            singleFile: false,
            fileType:'',
            fileSizeLimit:2048,
            width: 120,
            height: 20,
            name:'',
            visible: true,
            maxFileCount: -1
            //hideFileList: false,
            //tooltipText:''
        });
    },

    _initView: function () {
        WT.MultifileEditor.superclass._initView.apply(this);
        var o = this.options, self = this;
        this.uploadForm = $('<form enctype="multipart/form-data"></form>')
            .css('position', 'relative')
            .css('background', 'white');
        this.element = this.uploadForm;
        //一个div
        this.divWrap = $("<div></div>").css({
            'width': this.options.width + 'px',
            'height': this.options.height + 'px',
            'position': 'relative',
            'overflow': 'hidden'
        }).appendTo(this.uploadForm);

        this.fileupload = $('<input type="file" name="file"/>')
            .addClass('fr-fileupload').appendTo(this.divWrap);

        if (!o.singleFile) {
            this.fileupload[0].setAttribute("multiple", "multiple");
        }
        if (o.disabled) {
            this.fileupload[0].setAttribute("disabled", "disabled");
        }

        if (o.visible || !o.invisible) {
            var min = Math.min(this.options.height, this.options.width);
            var buttonSize = min > 32 ? 32 : min + 10;//按钮大小，按钮的背景图标被固定在左上角16*16的位置
            var pCountSize = min > 32 ? 12 : min * 0.7;//按钮大于32的时候，数字图标12*12，小于32为其0.7倍
            var bgSize = min > 32 ? 32 : 16

            // 让上传控件外观看起来是button
            this.surfaceButton = new WT.BaseButton({
                //icon: WT.MultifileEditor._const.bgIcon, 背景由css设置
            }).element.appendTo(this.divWrap).addClass("fr-fileupload-button").css({
                left: this.options.width > 32 ?
                    (this.options.width - 32) / 2 : 0,
                top: this.options.height > 32 ?
                    (this.options.height - 32) / 2 : 0,
                width: buttonSize,
                height: buttonSize,
                "background-size": bgSize + '' +  bgSize
            });


            this.surfaceButton.on(FR.Events.CLICK, function () {
                $('.fr-fileupload', self.element).click();//点击按钮事件传递给点击input
            });
            if (o.tooltipText) {
                var toolSpan = $("<span/>").addClass("fr-fileupload-tooltipspan");
                this.tooltipDiv = $("<div/>").css({
                    left: buttonSize + 7 + 'px',
                    top: this.options.height > 32 ?
                        (this.options.height - 32) / 2 : 0,
                    height: 16 + 'px'
                }).append(toolSpan.text(o.tooltipText)).addClass("fr-fileupload-tooltip").appendTo(this.uploadForm);
            }
            this.$preview = this.surfaceButton;//文件个数预览界面
            if (!o.singleFile) {
                this.$previewCount = $('<div class="fr-fileupload-preview-count"/>').text(0)
                    .appendTo(this.divWrap).css({//保持个数数字在红圈
                        left: this.options.width > 32 ?
                            (this.options.width - 32) / 2 + 18 : this.surfaceButton.width() - 10,
                        top: this.options.height > 32 ?
                            (this.options.height - 32) / 2 + 4 : 2,
                        width: pCountSize,
                        height: pCountSize,
                        'border-radius': pCountSize,
                        'font-size': pCountSize * 0.6
                    });
            }

            if (o.disabled) {
                $('.fr-fileupload', this.element).attr('disabled', true);
                $('.fr-fileupload-button', this.element).attr('disabled', true)
            }
        } else {
            this.$preview = this.element;
        }


        //使用noswfupload
        this.wrap = noswfupload.wrap((this.fileupload)[0], o.fileSizeLimit, o.singleFile ? 1: o.maxFileCount,
            o.width, o.height);
        var wrap = this.wrap;
        //onerror|onloadstart|onprogress|onerror|onload 文件上传的五个阶段，第二个onerror是上传过程中出错
        wrap.onerror = function () {
            noswfupload.text(this.dom.info, "WARNING: Unable to upload "
                + this.file.fileName);
        };

        wrap.onloadstart = function (rpe, xhr) {
            this.show(0, 0);
            noswfupload.text(this.dom.info, "Preparing for upload ... ");
        };

        wrap.onprogress = function (rpe, xhr) {
            //每个进度条的百分比
            this.show((this.sent + rpe.loaded) * 100 / this.total, rpe.loaded * 100 / rpe.total);

            noswfupload.text(this.dom.info, FR.i18nText("Fine-Engine_Basic_File_Uping_File") + ":  " + this.file.fileName);

            // fileSize is -1 only if browser does not support file info access
            // this if splits recent browsers from others
            if (this.file.fileSize !== -1) {
                // simulation property indicates when the progress event is fake
                if (rpe.simulation) {
                    noswfupload.text(this.dom.info,
                        FR.i18nText("Fine-Engine_Basic_File_Uping_File") + ":  " + this.file.fileName,
                        FR.i18nText("Fine-Engine_Basic_File_All_File_Uploaded") + noswfupload.size(this.sent + rpe.loaded));
                } else {
                    noswfupload.text(this.dom.info,
                        FR.i18nText("Fine-Engine_Basic_File_Uping_File") + ":  " + this.file.fileName,
                        FR.i18nText("Fine-Engine_Basic_File_Uploaded_File") + "： " + noswfupload.size(rpe.loaded),
                        FR.i18nText("Fine-Engine_Basic_File_All_File_Uploaded") + noswfupload.size(this.sent + rpe.loaded));
                }
            } else {
                // if fileSIze is -1 browser is using an iframe because it does not support
                // files sent via Ajax (XMLHttpRequest)
                // We can still show some information
                noswfupload.text(this.dom.info,
                    "Uploading: " + this.file.fileName,
                    "Sent: " + (this.sent / 100) + " out of " + (this.total / 100));
            }
        };

        // generated if there is something wrong during upload
        wrap.onerror = function () {
            // just inform the user something was wrong
            noswfupload.text(this.dom.info, "WARNING: Unable to upload "
                + this.file.fileName);
        };

        // generated when every file has been sent (one or more, it does not matter)
        wrap.onload = function (rpe, xhr) {
            var self_ = this;
            // just show everything is fine ...
            noswfupload.text(this.dom.info, "Upload complete");

            // ... and after a second reset the component
            setTimeout(function () {
                self_.clean(); // remove files from list
                self_.hide(); // hide progress bars and enable input file

                noswfupload.text(self_.dom.info, "");
                // enable again the submit button/element
            }, 1000);
            var warnMsg = '';
            _.each(self.wrap.attach_array, function (attach) {
                if (attach.errorCode === 21300002) {
                    warnMsg += attach.filename + " : " + FR.i18nText('Fine-Engine_Report_File_File_Too_Big') + wrap.maxSize + "KB; ";
                } else if (attach.errorCode === 21300003) {
                    var msg = wrap.fileType ? (FR.i18nText('Fine-Dec_Invalid_File_Type_To_Upload') + wrap.fileType) : FR.i18nText('Fine-Engine_Generic_Invalid_File_Type_Security');
                    warnMsg += attach.filename + msg + "; ";
                }
            });

            if (warnMsg) {
                FR.Msg.toast(warnMsg);
            }
            var filterAttachs = _.filter(self.wrap.attach_array, function (attach) {
                return attach.errorCode === undefined;
            });
            if (_.isEmpty(filterAttachs)) {
                self.wrap.attach_array = [];
                return;
            }

            self.showViewList();

            var attach = self.wrap.attach_array[0];
            self.fireEvent(FR.Events.CALLBACK, attach);
        };
        wrap.url = this.options.url ? this.options.url : FR.servletURL
            + '?op=fr_attach&cmd=ah_upload';
        //传到不同的服务器上, 会导致httpsession相互覆盖, 处理起来更麻烦了
        wrap.url += ((window.FS && window.FS.serverID) ? '&serverID='+ window.FS.serverID : "");
        wrap.fileType = o.fileType;   //文件类型限制
        wrap.attach_array = [];//文件列表
        wrap.attach_names = [];//文件名列表
        wrap.attachNum = 0;//文件数量
        this._dealValueWithEvents(o.value);
    },

    /**
     * @param {JSON} attach 文件对象
     * @private
     */
    _dealValueWithEvents: function (attach) {
        var self = this;
        if (FR.equals(attach, this.wrap.attach_array)
            || (this.wrap.attach_array.length === 1 && FR.equals(
                this.wrap.attach_array[0], attach))) {
            return;
        }
        if (($.isArray(attach) && attach.length > 0 && attach[0].attach_id)
            || (attach && attach.attach_id)) {
            var attach_array = $.isArray(attach) ? attach : [attach];
            this.wrap.attach_array = [];
            for (var i = 0; i < attach_array.length; i++) {
                // 编辑前setValue4Write(),不能让oldvalue跟getValue是同一个对象
                this.wrap.attach_array.push(attach_array[i]);
                var obj = {};
                this.wrap.files.push(obj);
            }
            this.showViewList();
            this.wrap.files.length = 0;
        }
        // 按delete或者backspace时候
        if (!attach) {
            this.reset();
        }
    },

    /**
     * 生成上传文件列表
     * @param {JSON} attach 上传的文件信息对象
     * @param {Number} i 位置索引
     * @returns {jQuery} 返回生成的列表DOM
     */
    createListItem: function (attach, i) {
        if (attach.errorCode) {
            return null;
        }
        var self = this;
        var download = $("<li></li>");
        var cancelButton;
        download
            .append(cancelButton = ($("<a class='fr-fileupload-progressCancel' href='#'> </a>"))
                .click(function (e) {
                    self.removeAttach(attach, download);
                    e.stopEvent();
                }).hide())
            .append($("<span class='fr-fileupload-fileNameItem'>"
                + self.wrap.attach_names[i] + " "
                + FR.__fileSizeFormat__(attach.fileSize) + "</span>")
                .bind("click", function () {
                    var attach_id = attach.attach_id;
                    window.open(FR.servletURL
                        + "?op=fr_attach&cmd=ah_download&id="
                        + attach_id);
                })
                .mouseover(function () {
                    $(this).css({color: 'blue' })
                })
                .mouseout(function () {
                    $(this).css({color: '' })
                })).addClass("fr-fileupload-listitem").mouseover(
            function () {
                cancelButton.show();
                $(this).css({'background-color': '#9FC5F8'})
            }).mouseout(function () {
            cancelButton.hide();
            $(this).css({'background-color': ''})
        });
        self.wrap.attachNum++;
        if (self.wrap.maxlength !== 1) {
            self.$previewCount.text(self.wrap.attachNum);
        }

        return download;
    },

    /**
     * 显示文件列表
     */
    showViewList: function () {
        var self = this;
        var fileListDiv;
        var fileListWrap;
        if (!self.options.hideFileList) {
            var fileListUl = $("ul", self.element);
            if (fileListUl.length === 0) {
                var contentDiv = $("<div class='fr-fileupload-popview'/>").appendTo(self.element).css({
                    marginTop:  18 - self.options.height / 2,
                    marginLeft : self.options.width / 2 + 18
                });
                fileListDiv = $("<div class='fr-fileupload-popview-list'/>").appendTo(contentDiv);
                fileListWrap = $("<ul/>").addClass("fr-fileupload-list").appendTo(fileListDiv);
            } else {
                fileListDiv = fileListUl.parent();
                fileListWrap = fileListUl;
            }
        }
        var wrap = self.wrap;
        this.imageURL = null;
        if (self.options.singleFile) {
            var o = this.options;
            var attach = wrap.attach_array[0];
            this.removeBackground();

            if (attach.attach_type === 'image') {
                var im_url = FR.servletURL + '?op=fr_attach&cmd=ah_image&id='
                    + attach.attach_id;
                self.$tempPreview = $("<img></img>").appendTo(this.divWrap).css({
                        left: self.element.outerWidth(true) - self.element.width(),
                        width: o.width,
                        height: o.height,
                        top: 0,
                        position: 'absolute'
                    }).attr('src', im_url);
                FR.lastTarget = self.$tempPreview;
                var $target = $(self.$tempPreview);
                this.imageURL = im_url;
                $target.css("cursor", "default").unbind("click", download)
            }
            wrap.attach_names[0] = attach.filename;
            if (fileListWrap) {
                fileListWrap.children().remove();
                fileListWrap.append(this.createListItem(attach, 0));
            }
        }
        // 多文件时要处理重名的问题
        if (!self.options.singleFile) {
            for (var i = wrap.attach_array.length - 1, m = 0; m < wrap.files.length; i--, m++) {
                wrap.attach_names[i] = wrap.attach_array[i].filename;
                var dup = 0;
                for (var j = 0; j < wrap.attach_array.length - wrap.files.length; j++) {
                    if (wrap.attach_names[i] === wrap.attach_array[j].filename) {
                        dup++;
                    }
                }
                if (dup > 0) {
                    wrap.attach_names[i] = FR.lengthenFileName(wrap.attach_array[i].filename, "(" + dup + ")");
                }
                fileListWrap && fileListWrap.append(this.createListItem(wrap.attach_array[i], i));
            }
        }
        self.wrap.attach_array = _.filter(self.wrap.attach_array, function (attach) {
            return attach.errorCode === undefined;
        });
        // ie杂项不支持max-height属性
        if (FR.Browser.isIE() && fileListDiv) {
            if (fileListDiv.height() > 160) {
                fileListDiv.height(160);
                if (fileListWrap.width() + 18 > fileListDiv.width()) {
                    fileListDiv.width(fileListWrap.width() + 18);
                }
            }
        }
        function download(e) {
            window.open(FR.servletURL + "?op=fr_attach&cmd=ah_download&id="
                + e.data);
            e.stopPropagation();
        }
    },

    /**
     * 移除已上传的文件
     * @param {JSON} attach 上传的文件对象
     * @param {jQuery} download 文件显示所在的DOM对象
     */
    removeAttach: function (attach, download) {
        var attach_id = attach.attach_id;
        var self = this;
        var wrap = this.wrap;
        FR.ajax({
            url: FR.servletURL + "?op=fr_attach&cmd=ah_release",
            data: {
                id: attach_id
            },
            complete: function (res, status) {
                if (status == 'success') {
                    if (download) {
                        download.remove();
                    }
                    for (var n = 0; n < wrap.attach_array.length; n++) {
                        if (wrap.attach_array[n].attach_id == attach_id) {
                            if (self.wrap.maxlength !== 1) {
                                wrap.attachNum--;
                                self.$previewCount.text(self.wrap.attachNum);
                                if (wrap.attachNum === 0) {
                                    $(".fr-fileupload-popview", self.element).remove();
                                }
                            }
                            wrap.attach_array.removeWeakEqual(wrap.attach_array[n]);
                            break;
                        }
                    }
                    if (self.wrap.maxlength === 1) {
                        $(".fr-fileupload-popview", self.element).remove();
                        self.removeBackground();
                    }
                    self.fireEvent(FR.Events.CALLBACK);
                }
            }
        })
    },

    /**
     * 重置背景图片
     * 格子的高度可能发生了改变 要调整
     * @param u
     */
    resetBackground: function(u) {
        var url = u || this.imageURL;
        this.removeBackground();
        if (this.options.tdCell) {
            this.options.tdCell.css('background', 'url(' + url
                + "&height=" + this.options.tdCell.height() + ") 0 0 no-repeat transparent");
        }
    },

    /**
     * 特指移除单文件上传中添加图片后的背景
     */
    removeBackground: function () {
        // 这个background是指单文件添加了图片的情况
        // 有两处需要移除 一个原始报表结构的td中 一个是动态生成的x-editor中
        // 还有可能用在表单啊
        if (this.options.tdCell) {
            this.options.tdCell.css('background-image', '');
        }
        var previousAtt = this.divWrap.children().eq(2);
        previousAtt.css('background-image', '');
        previousAtt.remove();
    },

    stopEdit: function (isToastError) {
        var o = this.options;
        if (!o.allowBlank && this.wrap.attach_array.length === 0) {
            isToastError && FR.Msg.toast(o.errorMsg4Blank);
            return false;
        }
        return true;
    },

    getValue: function () {
        if (!this.wrap.attach_array) {
            //return [];
            // shoc: 返回空数组有个问题,提交入库的时候空文件控件值到后台变成"[]"始终会入库一条记录，
            // 后台拦截了null、""等情况，在那里判断拦截这个不太合适，还是改这里了
            return "";
        }
        if (this.options.maxlength === 1 && this.wrap.attach_array[0]
            && this.wrap.attach_array[0].attach_type == "image") {
            return this.wrap.attach_array[0];
        }
        return this.wrap.attach_array.length === 0 ? "" : this.wrap.attach_array;
    },

    setValue: function (value) {
        this._dealValueWithEvents(value);
    },

    setEnable: function (enable) {
        FR.MultiFileEditor.superclass.setEnable.apply(this, arguments);
        if (this.$fileupload && this.$fileupload[0]) {
            if (enable) {
                this.$fileupload[0].removeAttribute("disabled");
            } else {
                this.$fileupload[0].setAttribute("disabled", "disabled");
            }
        }
    },

    /**
     * 是否显示预览图片
     * @returns {Boolean} 返回是否显示预览图片
     */
    isShowViewImage: function () {
        return this.options.showViewImage && this.options.maxlength === 1;
    },

    reset: function () {
        this.wrap.attach_array = [];
        this.wrap.attach_names = [];
        this.wrap.attachNum = 0;
        $('.fr-fileupload-popview', this.element).remove();
        // this.removeBackground();
    },

    destroy: function () {
        (this.element instanceof $) && this.element.remove();
    }
});

WT.MultifileEditor._const = {
    bgIcon : 'transparent url('
    + FR.servletURL
    + '?op=resource&resource=com/fr/web/images/file/upload.png) no-repeat scroll center center'
};
