/**
 * 密码框控件
 * @class WT.PasswordEditor
 *
 * @cfg {JSON} options 配置属性
 */
WT.PasswordEditor = FR.extend(WT.BaseEditor, {

    TYPE: 'WT.PasswordEditor',

    _defaultConfig: function () {
        return $.extend(WT.TextEditor.superclass._defaultConfig.apply(), {
            encryption: null
        });
    },

    /**
     * @extends WT.BaseEditor._initVariable()
     * @protected
     */
    _initVariable: function () {
        WT.TextEditor.superclass._initVariable.apply(this);
    },

    /**
     * @extends WT.BaseEditor._initView()
     * @protected
     */
    _initView: function () {
        WT.TextEditor.superclass._initView.apply(this);
        this.editor.element.attr('type', 'password');
        this.element.css('background', 'white');
    },

    getValue: function () {
        return this.options.encryption
            ? this.options.encryption(this.options.value)
            : this.options.value;
    }
});