/**
 * 新填报下的文本域控件
 * @class WT.TextArea
 * @extends WT.BaseEditor
 *
 * @cfg {JSON} options 配置属性
 */
WT.TextArea = FR.extend(WT.BaseEditor, {

    TYPE: 'WT.TextArea',

    _defaultConfig: function () {
        return $.extend(WT.TextArea.superclass._defaultConfig.apply(), {
            //
        });
    },

    /**
     * @extends WT.BaseEditor._initView()
     * @protected
     */
    _initView: function () {
        WT.TextEditor.superclass._initView.apply(this);
        this.element.css('background', 'white');
    },

    _createRootEl: function () {
        return WT.dom.createJQueryElement('div', 'wt-absolute-layout wt-text-editor-border wt-border-box');
    },

    _createEditor: function () {
        var o = this.options;
        var editor = new WT.Input({
            element: "<textarea style='resize: none;' class='wt-text-editor wt-border-box'/>",
            allowBlank: true,
            supportWrap: true
        });
        editor.element.css({
            'font-size': o.fontSize,
            height: '100%'
        });
        editor.element.addClass('wt-scrollbar');
        return editor;
    }
});