/**
 新填报下的下拉树
 * @class WT.TreeCombo
 * @extends WT.Widget
 *
 */
WT.TreeCombo = FR.extend(WT.Widget, {

    TYPE: 'WT.TreeCombo',

    _initView: function () {
        var o = this.options, self = this;
        this.element = WT.dom.createJQueryElement('div', 'wt-absolute-layout');
        this.element.css({
            left: o.left,
            top: o.top,
            width: o.width,
            height: o.height
        });
        var oo = $.extend({}, o, {
            renderEl: this.element
        });
        if (oo.location) {
            var l = FR.cellStr2ColumnRow(oo.location);
            oo.widgetUrl = FR.buildServletUrl({
                op: 'widget',
                location: {
                    column: l.col,
                    row: l.row,
                    reportIndex: oo.reportIndex
                },
                sessionID: FR.SessionMgr.getSessionID()
            });
        }
        this.tree = new FR.TreeComboBoxEditor(oo);
        this.tree.on(FR.Events.DEFAULTINIT, function () {
            self.fireEvent(FR.Events.DEFAULTINIT);
        });
        this.tree.on(FR.Events.BEFORESTATECHANGE, function () {
            self.fireEvent(FR.Events.BEFORESTATECHANGE);
        });
        this.tree.on(FR.Events.AFTERBUILD, function () {
            self.fireEvent(FR.Events.AFTERBUILD);
        });
        this.tree.on(FR.Events.CLICK, function (item) {
            self.fireEvent(FR.Events.CLICK, item);
        });
        this.tree.on(FR.Events.AFTEREDIT, function () {
            self.fireEvent(FR.Events.AFTEREDIT);
        });
        this.tree.on(FR.Events.NOSELECT, function () {
            self.fireEvent(FR.Events.NOSELECT);
        });
        this.tree.on(FR.Events.DEALSELECTEDNODES, function () {
            self.fireEvent(FR.Events.DEALSELECTEDNODES);
        });
        this.tree.on(FR.Events.BEFOREEDIT, function () {
            if (WT.Keys.enable()) {
                WT.Keys.enable(false);
            }
            self.fireEvent(FR.Events.BEFOREEDIT);
            this.detached = false;
        });
        this.tree.on(FR.Events.STOPEDIT, function () {
            var popupShow1 = self.tree.isExpanded();
            setTimeout(function () {
                var popupShow2 = self.tree.isExpanded();
                if (!popupShow1 && !popupShow2) {
                    if (!WT.Keys.enable()) {
                        WT.Keys.enable(true);
                    }
                    self.fireEvent(FR.Events.STOPEDIT)
                }
            }, 30);
            this.detachedOffset = {"top": this.element.offset().top, "left": this.element.offset().left};
            this.detachedTW = this.$view.width();
            this.detachedTH = this.$view.height();
            this.detached = true;
        });
        this.tree.on(WT.TreeCombo.EVENT_NODEADD, function () {
            self.fireEvent(WT.TreeCombo.EVENT_NODEADD);
        });
        this.tree.createDependencePara4Data = function () {
            var parameter = {};
            if (!FR.isEmptyObj(o.dependence) && o.paraProvider) {
                var dependence = {};
                for (var k in o.dependence) {
                    var paraVal = o.paraProvider.getPara(o.dependence[k]);
                    if (!FR.isEmpty(paraVal)) {
                        dependence[WT.isIntString(k) ? o.dependence[k].toUpperCase() : k.toUpperCase()] = paraVal;
                    }
                }
                if (!WT.isEmpty(dependence)) {
                    parameter.dependence = dependence;
                }
            }
            return {
                parameter: parameter
            }
        }.bind(this.tree);
    },

    _handleInValue: function (v) {
        var o = this.options;
        while (WT.isArray(v)) {
            if (v.length === 0) {
                return [];
            }
            if (o.mutiSelection) {
                if (!WT.isArray(v[0]) || !WT.isArray(v[0][0])) {
                    return v;
                }
            } else {
                if (!WT.isArray(v[0])) {
                    return v;
                }
            }
            v = v[0];
        }
        return v;
    },

    getOriginValue: function () {
        return this.tree.getFullPathValue();
    },

    getValue: function () {
        return this.tree.getValue();
    },

    getText: function () {
        return this.tree.getText();
    },

    setValue: function (v) {
        this.tree.setValue(this._handleInValue(v));
    },

    setText: function (t) {
        this.tree.reset();
        this.tree.setText(t);
    },

    setEnable: function (enable) {
        this.tree.setEnable(enable);
    },

    isEnable: function () {
        return this.tree.isEnabled();
    },

    stopEdit: function (isToastError) {
        var valid = this.verify();
        if (isToastError === true && !valid) {
            FR.Msg.toast(this.errMsg)
        }
        return valid;
    },
    verify: function () {
        var isValidate = this.tree.isValidate();
        if (!isValidate) {
            this.errMsg = this.tree.getErrorMsg();
        }
        return isValidate;
    },

    couldUsedAsEditor: function () {
        return true;
    },

    focus: function () {
        if (this._focusAction === true) {
            return;
        }
        this._focusAction = true;
        this.tree.editComp.focus();
        this._focusAction = false;
    },

    reset: function () {
        this.tree.reset();
    },
    destroy: function () {
        this.tree && this.tree.purgeListeners();
        this.purgeListeners();
        this.element.empty();
        this.element.remove();
        this.tree = null;
        this.element = null;
    }
});

WT.TreeCombo.EVENT_NODEADD = 'nodeadd';