/**
 * 新填报下的带数字的按钮
 * @class WT.BadgeButton
 * @extends WT.BaseButton
 *
 * @cfg {JSON} options 配置属性
 */
WT.BadgeButton = FR.extend(WT.BaseButton, {

    TYPE: 'WT.BadgeButton',

    _createAdditionalItem: function(items) {
        this.badge = BI.createWidget({
            type: "bi.label"
        });
        this.badge.setStyle({
            'font-size': 12,
            background: 'yellow',
            color: 'red',
            border: '1px solid #FFA54F',
            '-moz-border-radius': '3px',
            '-webkit-border-radius': '3px',
            'margin-left': '4px',
            padding: '0 2px',
            display: 'none'
        });
        items.push(this.badge);
    },

    setBadge: function (count) {
        if (WT.isNumber(count) && count > 0) {
            this.badge.setText(count);
            this.badge.setStyle({
                display: 'block'
            });
        }
        else {
            this.badge.setText('');
            this.badge.setStyle({
                display: 'none'
            });
        }
    }

});