/**
 * 网页框
 *
 * Created by rinoux on 2017/4/20.
 *
 */
WT.WebBox = FR.extend(WT.Widget, {

    TYPE: 'WT.WebBox',

    _defaultConfig: function () {
        return $.extend(WT.WebBox.superclass._defaultConfig.apply(), {
            baseName: 'wt_web_frame',
            baseClass: 'fr_iframeeditor',
            name: '',
            url: '',
            height: '100%',
            width: '100%',
            horizontalScrollbarVisibility: true,
            verticalScrollbarVisibility: true,
            controlAttr:''//原填报不知道干嘛的，先加上
        });
    },
    _initVariable: function () {
        WT.WebBox.superclass._initVariable.apply(this);
        this.dataSource = this.options.dataSource;
    },
    _initView: function () {
        var o = this.options;
        this.element = this._createRootEl();
        this.element.css({
            width: '100%',
            height: '100%'
        }).attr({
            widgetName:o.name
        });
        this.frame = this._createFrame();
        this.frame.element.addClass(o.baseClass).css({
                left: o.left,
                top: o.top,
                height: o.height,
                width: o.width
            }).attr({
            name: this._generateName(),
            id: this._generateName(),
            frameborder: 0,
            scrolling: !o.horizontalScrollbarVisibility && !o.verticalScrollbarVisibility
                ? 'no'
                : 'yes'
        }).appendTo(this.element);

        //滚动条设置
        this.frame.onload = function () {
            if (!o.horizontalScrollbarVisibility || !o.verticalScrollbarVisibility) {
                try {
                    if (this.contentWindow) {
                        //网页框内容
                        var doc = this.contentWindow.document;
                        var cc = $('.content-container', $(doc));

                        if (cc.length > 0) {
                            setOverflow(cc);
                        } else {
                            // 有可能是表单 html和body都要设置
                            setOverflow($(doc.documentElement));
                            setOverflow($(doc.body));
                        }
                        function setOverflow(cc) {
                            if (!o.horizontalScrollbarVisibility) {
                                cc.css('overflow-x', 'hidden');
                            }
                            if (!o.verticalScrollbarVisibility) {
                                cc.css('overflow-y', 'hidden');
                            }
                        }
                    }
                } catch (e) {
                    console && console.log("error");
                }
            }
        };

        this.frame.element.css('overflow-x', o.horizontalScrollbarVisibility ? 'auto' : 'hidden');
        this.frame.element.css('overflow-y', o.verticalScrollbarVisibility ? 'auto' : 'hidden');

        if (o.disabled) {
            this.element.addClass('ui-state-disabled');
        }
        if (o.controlAttr) {
            this.setValue(o.controlAttr)
        } else if (o.url) {
            this._loadWebBox();
        }
        this.setVisible(!o.invisible);
    },
    _createFrame : function () {
        return new BI.Iframe({
            baseClass:''
        });
    },
    _loadWebBox : function () {
        var o = this.options, self = this;
        var url = o.url;
        if (this.dataSource) {
            this.dataSource.once(WT.DataSource.EVENT_DATA_UPDATED, function (newData) {
                var args = WT.reduce(newData, function (prev, next) {
                    return $.extend(prev, next);
                }, {});
                if (!WT.isEmpty(args)) {
                    url = url.appendQuery(args);
                }
                self._setUrl(url);
            });
            this.dataSource.loadData({}, '');
        } else {
            this._setUrl(url);
        }
    },
    /**
     * 创建根元素
     * @returns {*|jQuery|HTMLElement}
     * @private
     */
    _createRootEl: function () {
        return $('<div class="ui-state-enabled"></div>');
    },
    _setUrl: function (url) {
        this.options.url = url;
        this.frame.element.attr('src', url);

    },
    _getUrl: function () {
        return this.options.url;
    },
    //没有名称时生成一个名字
    _generateName: function () {
        if (this.options.name) {
            return this.options.name;
        } else {
            var len = $('iframe' + this.options.baseClass).length;
            while ($('iframe[name=' + this.options.baseName + len + ']').length !== 0) {
                len++;
            }
            return this.options.baseName + len;
        }
    },
    /**
     * 启用控件
     * @param enable
     */
    setEnable: function (enable) {
        WT.WebBox.superclass.setEnable.apply(this, arguments);
        if ($('ui-state-enabled')) {
            this.element.addClass('ui-state-disabled');
        } else {
            this.element.addClass('ui-state-enabled');
        }
    },

    getValue: function () {
        return '';
    },

    destroy: function () {
        (this.element instanceof $) && this.element.remove();
    }
});
